test-lib: handle TEST_OUTPUT_DIRECTORY with spaces
[git/git.git] / t / test-lib.sh
CommitLineData
c74c7203 1# Test framework for git. See t/README for usage.
e1970ce4
JH
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
3c8f12c9
JH
18# Test the binaries we have just built. The tests are kept in
19# t/ subdirectory and are run in 'trash directory' subdirectory.
20if test -z "$TEST_DIRECTORY"
21then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
85176d72
FC
26else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
3c8f12c9
JH
30fi
31if test -z "$TEST_OUTPUT_DIRECTORY"
32then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36fi
37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
2006f0ad
RR
39################################################################
40# It appears that people try to run tests without building...
41"$GIT_BUILD_DIR/git" >/dev/null
42if test $? != 1
43then
44 echo >&2 'error: you do not seem to have built git yet.'
45 exit 1
46fi
47
3c8f12c9
JH
48. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
49export PERL_PATH SHELL_PATH
50
4cde519f
RR
51# if --tee was passed, write the output not only to the terminal, but
52# additionally to the file test-results/$BASENAME.out, too.
53case "$GIT_TEST_TEE_STARTED, $* " in
54done,*)
55 # do not redirect again
56 ;;
57*' --tee '*|*' --va'*)
2d14e13c
JK
58 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
59 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
4cde519f 60 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
925bdc92
JK
61 echo $? >"$BASE.exit") | tee "$BASE.out"
62 test "$(cat "$BASE.exit")" = 0
4cde519f
RR
63 exit
64 ;;
65esac
66
e1970ce4 67# For repeatability, reset the environment to known value.
d5c1b7c2 68# TERM is sanitized below, after saving color control sequences.
e1970ce4 69LANG=C
899460f3 70LC_ALL=C
d9bdd39e 71PAGER=cat
e1970ce4 72TZ=UTC
d5c1b7c2 73export LANG LC_ALL PAGER TZ
8ff99e74 74EDITOR=:
661bfd13
SL
75# A call to "unset" with no arguments causes at least Solaris 10
76# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
77# deriving from the command substitution clustered with the other
78# ones.
3c8f12c9 79unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 80 my @env = keys %ENV;
730477f1
JL
81 my $ok = join("|", qw(
82 TRACE
83 DEBUG
84 USE_LOOKUP
85 TEST
86 .*_TEST
87 PROVE
88 VALGRIND
ac001282 89 UNZIP
edb54081 90 PERF_
e2a0ccc0 91 CURL_VERBOSE
730477f1
JL
92 ));
93 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
94 print join("\n", @vars);
95')
5adf84eb 96unset XDG_CONFIG_HOME
8bade1e1 97unset GITPERLLIB
29e55cd5
JH
98GIT_AUTHOR_EMAIL=author@example.com
99GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
100GIT_COMMITTER_EMAIL=committer@example.com
101GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 102GIT_MERGE_VERBOSITY=5
f8246281
JH
103GIT_MERGE_AUTOEDIT=no
104export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
105export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
106export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 107export EDITOR
e1970ce4 108
124647c4
KB
109# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
110GIT_TRACE_BARE=1
111export GIT_TRACE_BARE
112
5d9fc888
TG
113if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
114then
115 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
116 export GIT_INDEX_VERSION
117fi
118
a731fa91
EP
119# Add libc MALLOC and MALLOC_PERTURB test
120# only if we are not executing the test with valgrind
1b3185fc 121if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
ee1431bf 122 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
123then
124 setup_malloc_check () {
125 : nothing
126 }
127 teardown_malloc_check () {
128 : nothing
129 }
130else
131 setup_malloc_check () {
132 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
133 export MALLOC_CHECK_ MALLOC_PERTURB_
134 }
135 teardown_malloc_check () {
136 unset MALLOC_CHECK_ MALLOC_PERTURB_
137 }
138fi
a731fa91 139
b0f4c908
JK
140: ${ASAN_OPTIONS=detect_leaks=0}
141export ASAN_OPTIONS
142
886a3907
JH
143# Protect ourselves from common misconfiguration to export
144# CDPATH into the environment
145unset CDPATH
146
5565f47c 147unset GREP_OPTIONS
ac001282 148unset UNZIP
5565f47c 149
3d5c0cc9 150case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756 1511|2|true)
025232e8 152 GIT_TRACE=4
1c0cc756 153 ;;
6ce4e61f
CC
154esac
155
cd3c095c
JH
156# Convenience
157#
158# A regexp to match 5 and 40 hexdigits
159_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
160_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
161
3749fde5
JH
162# Zero SHA-1
163_z40=0000000000000000000000000000000000000000
164
3f4ab627
JH
165# Line feed
166LF='
167'
168
a42643aa
JK
169# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
170# when case-folding filenames
171u200c=$(printf '\342\200\214')
172
173export _x05 _x40 _z40 LF u200c
342e9ef2 174
e1970ce4
JH
175# Each test should start with something like this, after copyright notices:
176#
177# test_description='Description of this test...
178# This test checks if command xyzzy does the right thing...
179# '
180# . ./test-lib.sh
d5c1b7c2 181test "x$TERM" != "xdumb" && (
ca92a660
RH
182 test -t 1 &&
183 tput bold >/dev/null 2>&1 &&
184 tput setaf 1 >/dev/null 2>&1 &&
185 tput sgr0 >/dev/null 2>&1
186 ) &&
187 color=t
e1970ce4 188
e1970ce4
JH
189while test "$#" -ne 0
190do
191 case "$1" in
192 -d|--d|--de|--deb|--debu|--debug)
193 debug=t; shift ;;
886856ab
JH
194 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
195 immediate=t; shift ;;
5e2c08c6 196 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 197 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
0445e6f0
IB
198 -r)
199 shift; test "$#" -ne 0 || {
200 echo 'error: -r requires an argument' >&2;
201 exit 1;
202 }
203 run_list=$1; shift ;;
204 --run=*)
0ff74101 205 run_list=${1#--*=}; shift ;;
e1970ce4 206 -h|--h|--he|--hel|--help)
570f3226 207 help=t; shift ;;
e1970ce4
JH
208 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
209 verbose=t; shift ;;
ff09af3f 210 --verbose-only=*)
0ff74101 211 verbose_only=${1#--*=}
ff09af3f 212 shift ;;
1ece1274 213 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
214 # Ignore --quiet under a TAP::Harness. Saying how many tests
215 # passed without the ok/not ok details is always an error.
216 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
217 --with-dashes)
218 with_dashes=t; shift ;;
55db1df0 219 --no-color)
faa4bc35 220 color=; shift ;;
4e1be63c 221 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
952af351
TR
222 valgrind=memcheck
223 shift ;;
224 --valgrind=*)
0ff74101 225 valgrind=${1#--*=}
952af351 226 shift ;;
5dfc368f 227 --valgrind-only=*)
0ff74101 228 valgrind_only=${1#--*=}
5dfc368f 229 shift ;;
44138559
JS
230 --tee)
231 shift ;; # was handled already
f423ef5f 232 --root=*)
0ff74101 233 root=${1#--*=}
f423ef5f 234 shift ;;
bb79af9d
JK
235 --chain-lint)
236 GIT_TEST_CHAIN_LINT=1
237 shift ;;
238 --no-chain-lint)
239 GIT_TEST_CHAIN_LINT=0
240 shift ;;
a136f6d8
JK
241 -x)
242 trace=t
243 verbose=t
244 shift ;;
e1970ce4 245 *)
1f729dca 246 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
247 esac
248done
249
26a07309 250if test -n "$valgrind_only"
5dfc368f
TR
251then
252 test -z "$valgrind" && valgrind=memcheck
253 test -z "$verbose" && verbose_only="$valgrind_only"
254elif test -n "$valgrind"
255then
256 verbose=t
257fi
952af351 258
ca92a660
RH
259if test -n "$color"
260then
d5c1b7c2
RH
261 # Save the color control sequences now rather than run tput
262 # each time say_color() is called. This is done for two
263 # reasons:
264 # * TERM will be changed to dumb
265 # * HOME will be changed to a temporary directory and tput
266 # might need to read ~/.terminfo from the original HOME
267 # directory to get the control sequences
268 # Note: This approach assumes the control sequences don't end
269 # in a newline for any terminal of interest (command
270 # substitutions strip trailing newlines). Given that most
271 # (all?) terminals in common use are related to ECMA-48, this
272 # shouldn't be a problem.
273 say_color_error=$(tput bold; tput setaf 1) # bold red
274 say_color_skip=$(tput setaf 4) # blue
275 say_color_warn=$(tput setaf 3) # brown/yellow
276 say_color_pass=$(tput setaf 2) # green
277 say_color_info=$(tput setaf 6) # cyan
278 say_color_reset=$(tput sgr0)
279 say_color_="" # no formatting for normal text
ca92a660 280 say_color () {
d5c1b7c2
RH
281 test -z "$1" && test -n "$quiet" && return
282 eval "say_color_color=\$say_color_$1"
ca92a660 283 shift
d5c1b7c2 284 printf "%s\\n" "$say_color_color$*$say_color_reset"
ca92a660
RH
285 }
286else
287 say_color() {
288 test -z "$1" && test -n "$quiet" && return
289 shift
290 printf "%s\n" "$*"
291 }
292fi
293
d5c1b7c2
RH
294TERM=dumb
295export TERM
296
55db1df0
PH
297error () {
298 say_color error "error: $*"
6e7b5aaf 299 GIT_EXIT_OK=t
55db1df0
PH
300 exit 1
301}
302
303say () {
304 say_color info "$*"
305}
306
570f3226
MB
307test "${test_description}" != "" ||
308error "Test script did not set test_description."
309
310if test "$help" = "t"
311then
cb1aefda 312 printf '%s\n' "$test_description"
570f3226
MB
313 exit 0
314fi
315
4d9d62fa 316exec 5>&1
781f76b1 317exec 6<&0
e1970ce4
JH
318if test "$verbose" = "t"
319then
320 exec 4>&2 3>&1
321else
322 exec 4>/dev/null 3>/dev/null
323fi
324
d88785e4
JK
325# Send any "-x" output directly to stderr to avoid polluting tests
326# which capture stderr. We can do this unconditionally since it
327# has no effect if tracing isn't turned on.
328#
329# Note that this sets up the trace fd as soon as we assign the variable, so it
330# must come after the creation of descriptor 4 above. Likewise, we must never
331# unset this, as it has the side effect of closing descriptor 4, which we
332# use to show verbose tests to the user.
333#
334# Note also that we don't need or want to export it. The tracing is local to
335# this shell, and we would not want to influence any shells we exec.
336BASH_XTRACEFD=4
337
e1970ce4
JH
338test_failure=0
339test_count=0
41ac414e
JH
340test_fixed=0
341test_broken=0
2d84e9fb 342test_success=0
e1970ce4 343
d998bd4a
ÆAB
344test_external_has_tap=0
345
faa4bc35 346die () {
6e7b5aaf
CB
347 code=$?
348 if test -n "$GIT_EXIT_OK"
349 then
350 exit $code
351 else
352 echo >&5 "FATAL: Unexpected exit with code $code"
353 exit 1
354 fi
faa4bc35
CB
355}
356
6e7b5aaf 357GIT_EXIT_OK=
35641310 358trap 'die' EXIT
da706545 359trap 'exit $?' INT
41184273 360
12a29b1a
TR
361# The user-facing functions are loaded from a separate file so that
362# test_perf subshells can have them too
3c8f12c9 363. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 364
886856ab 365# You are not expected to call test_ok_ and test_failure_ directly, use
3fa36666 366# the test_expect_* functions instead.
886856ab
JH
367
368test_ok_ () {
d5d9de1b 369 test_success=$(($test_success + 1))
633fe50a 370 say_color "" "ok $test_count - $@"
e1970ce4
JH
371}
372
886856ab 373test_failure_ () {
d5d9de1b 374 test_failure=$(($test_failure + 1))
633fe50a 375 say_color error "not ok $test_count - $1"
bf0dd8a8 376 shift
cb1aefda 377 printf '%s\n' "$*" | sed -e 's/^/# /'
6e7b5aaf 378 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
379}
380
41ac414e 381test_known_broken_ok_ () {
41ac414e 382 test_fixed=$(($test_fixed+1))
633fe50a 383 say_color error "ok $test_count - $@ # TODO known breakage vanished"
41ac414e
JH
384}
385
386test_known_broken_failure_ () {
41ac414e 387 test_broken=$(($test_broken+1))
633fe50a 388 say_color warn "not ok $test_count - $@ # TODO known breakage"
41ac414e 389}
886856ab
JH
390
391test_debug () {
8e832ebc 392 test "$debug" = "" || eval "$1"
e1970ce4
JH
393}
394
e6a6ddc9
TR
395match_pattern_list () {
396 arg="$1"
397 shift
398 test -z "$*" && return 1
399 for pattern_
400 do
401 case "$arg" in
402 $pattern_)
403 return 0
404 esac
405 done
406 return 1
407}
408
0445e6f0
IB
409match_test_selector_list () {
410 title="$1"
411 shift
412 arg="$1"
413 shift
414 test -z "$1" && return 0
415
416 # Both commas and whitespace are accepted as separators.
417 OLDIFS=$IFS
418 IFS=' ,'
419 set -- $1
420 IFS=$OLDIFS
421
422 # If the first selector is negative we include by default.
423 include=
424 case "$1" in
425 !*) include=t ;;
426 esac
427
428 for selector
429 do
430 orig_selector=$selector
431
432 positive=t
433 case "$selector" in
434 !*)
435 positive=
436 selector=${selector##?}
437 ;;
438 esac
439
440 test -z "$selector" && continue
441
442 case "$selector" in
443 *-*)
444 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
445 then
446 echo "error: $title: invalid non-numeric in range" \
447 "start: '$orig_selector'" >&2
448 exit 1
449 fi
450 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
451 then
452 echo "error: $title: invalid non-numeric in range" \
453 "end: '$orig_selector'" >&2
454 exit 1
455 fi
456 ;;
457 *)
458 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
459 then
460 echo "error: $title: invalid non-numeric in test" \
461 "selector: '$orig_selector'" >&2
462 exit 1
463 fi
464 esac
465
466 # Short cut for "obvious" cases
467 test -z "$include" && test -z "$positive" && continue
468 test -n "$include" && test -n "$positive" && continue
469
470 case "$selector" in
471 -*)
472 if test $arg -le ${selector#-}
473 then
474 include=$positive
475 fi
476 ;;
477 *-)
478 if test $arg -ge ${selector%-}
479 then
480 include=$positive
481 fi
482 ;;
483 *-*)
484 if test ${selector%%-*} -le $arg \
485 && test $arg -le ${selector#*-}
486 then
487 include=$positive
488 fi
489 ;;
490 *)
491 if test $arg -eq $selector
492 then
493 include=$positive
494 fi
495 ;;
496 esac
497 done
498
499 test -n "$include"
500}
501
ff09af3f
TR
502maybe_teardown_verbose () {
503 test -z "$verbose_only" && return
504 exec 4>/dev/null 3>/dev/null
505 verbose=
506}
507
508last_verbose=t
509maybe_setup_verbose () {
510 test -z "$verbose_only" && return
26a07309 511 if match_pattern_list $test_count $verbose_only
ff09af3f
TR
512 then
513 exec 4>&2 3>&1
514 # Emit a delimiting blank line when going from
515 # non-verbose to verbose. Within verbose mode the
516 # delimiter is printed by test_expect_*. The choice
517 # of the initial $last_verbose is such that before
518 # test 1, we do not print it.
519 test -z "$last_verbose" && echo >&3 ""
520 verbose=t
521 else
522 exec 4>/dev/null 3>/dev/null
523 verbose=
524 fi
525 last_verbose=$verbose
526}
527
5dfc368f
TR
528maybe_teardown_valgrind () {
529 test -z "$GIT_VALGRIND" && return
530 GIT_VALGRIND_ENABLED=
531}
532
533maybe_setup_valgrind () {
534 test -z "$GIT_VALGRIND" && return
26a07309 535 if test -z "$valgrind_only"
5dfc368f
TR
536 then
537 GIT_VALGRIND_ENABLED=t
538 return
539 fi
540 GIT_VALGRIND_ENABLED=
541 if match_pattern_list $test_count $valgrind_only
542 then
543 GIT_VALGRIND_ENABLED=t
544 fi
545}
546
9b5fe78b
JK
547want_trace () {
548 test "$trace" = t && test "$verbose" = t
549}
550
a136f6d8
JK
551# This is a separate function because some tests use
552# "return" to end a test_expect_success block early
553# (and we want to make sure we run any cleanup like
554# "set +x").
555test_eval_inner_ () {
556 # Do not add anything extra (including LF) after '$*'
557 eval "
9b5fe78b 558 want_trace && set -x
a136f6d8
JK
559 $*"
560}
561
a7c58f28 562test_eval_ () {
a136f6d8
JK
563 # We run this block with stderr redirected to avoid extra cruft
564 # during a "-x" trace. Once in "set -x" mode, we cannot prevent
565 # the shell from printing the "set +x" to turn it off (nor the saving
566 # of $? before that). But we can make sure that the output goes to
567 # /dev/null.
568 #
569 # The test itself is run with stderr put back to &4 (so either to
570 # /dev/null, or to the original stderr if --verbose was used).
571 {
572 test_eval_inner_ "$@" </dev/null >&3 2>&4
573 test_eval_ret_=$?
9b5fe78b 574 if want_trace
a136f6d8
JK
575 then
576 set +x
577 if test "$test_eval_ret_" != 0
578 then
579 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
580 fi
581 fi
582 } 2>/dev/null
583 return $test_eval_ret_
a7c58f28
JN
584}
585
4d9d62fa 586test_run_ () {
b6b0afdc 587 test_cleanup=:
b586744a 588 expecting_failure=$2
bb79af9d 589
92b269f5 590 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
2a01ef8c
JK
591 # turn off tracing for this test-eval, as it simply creates
592 # confusing noise in the "-x" output
593 trace_tmp=$trace
594 trace=
bb79af9d
JK
595 # 117 is magic because it is unlikely to match the exit
596 # code of other programs
597 test_eval_ "(exit 117) && $1"
598 if test "$?" != 117; then
599 error "bug in the test script: broken &&-chain: $1"
600 fi
2a01ef8c 601 trace=$trace_tmp
bb79af9d
JK
602 fi
603
a57397b0 604 setup_malloc_check
a7c58f28 605 test_eval_ "$1"
b6b0afdc 606 eval_ret=$?
a57397b0 607 teardown_malloc_check
b586744a 608
a136f6d8
JK
609 if test -z "$immediate" || test $eval_ret = 0 ||
610 test -n "$expecting_failure" && test "$test_cleanup" != ":"
b586744a 611 then
1b3185fc 612 setup_malloc_check
a7c58f28 613 test_eval_ "$test_cleanup"
1b3185fc 614 teardown_malloc_check
b586744a 615 fi
1c0cc756
RJ
616 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
617 then
57e1538a
ÆAB
618 echo ""
619 fi
aa0bcf96 620 return "$eval_ret"
4d9d62fa
PR
621}
622
ae75342c 623test_start_ () {
8586f98b 624 test_count=$(($test_count+1))
ff09af3f 625 maybe_setup_verbose
5dfc368f 626 maybe_setup_valgrind
ae75342c
TR
627}
628
629test_finish_ () {
630 echo >&3 ""
5dfc368f 631 maybe_teardown_valgrind
ff09af3f 632 maybe_teardown_verbose
ae75342c
TR
633}
634
635test_skip () {
04ece593 636 to_skip=
ef2ac68d 637 skipped_reason=
e6a6ddc9
TR
638 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
639 then
640 to_skip=t
ef2ac68d 641 skipped_reason="GIT_SKIP_TESTS"
e6a6ddc9 642 fi
05236a5e
JN
643 if test -z "$to_skip" && test -n "$test_prereq" &&
644 ! test_have_prereq "$test_prereq"
a7bb3940
JS
645 then
646 to_skip=t
ef2ac68d 647
07431fc8 648 of_prereq=
05236a5e 649 if test "$missing_prereq" != "$test_prereq"
07431fc8 650 then
05236a5e 651 of_prereq=" of $test_prereq"
07431fc8 652 fi
ef2ac68d
IB
653 skipped_reason="missing $missing_prereq${of_prereq}"
654 fi
0445e6f0
IB
655 if test -z "$to_skip" && test -n "$run_list" &&
656 ! match_test_selector_list '--run' $test_count "$run_list"
657 then
658 to_skip=t
659 skipped_reason="--run"
660 fi
07431fc8 661
ef2ac68d
IB
662 case "$to_skip" in
663 t)
633fe50a 664 say_color skip >&3 "skipping test: $@"
ef2ac68d 665 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
04ece593
JH
666 : true
667 ;;
668 *)
669 false
670 ;;
671 esac
672}
673
342e9ef2
TR
674# stub; perf-lib overrides it
675test_at_end_hook_ () {
676 :
677}
678
e1970ce4 679test_done () {
6e7b5aaf 680 GIT_EXIT_OK=t
2d84e9fb 681
1c0cc756
RJ
682 if test -z "$HARNESS_ACTIVE"
683 then
342e9ef2 684 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5 685 mkdir -p "$test_results_dir"
dd78478f
FC
686 base=${0##*/}
687 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
8ef1abe5 688
c54e6be7
ML
689 cat >>"$test_results_path" <<-EOF
690 total $test_count
691 success $test_success
692 fixed $test_fixed
693 broken $test_broken
694 failed $test_failure
695
696 EOF
8ef1abe5 697 fi
41ac414e
JH
698
699 if test "$test_fixed" != 0
700 then
633fe50a 701 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
702 fi
703 if test "$test_broken" != 0
704 then
633fe50a 705 say_color warn "# still have $test_broken known breakage(s)"
b73d9a23
AS
706 fi
707 if test "$test_broken" != 0 || test "$test_fixed" != 0
708 then
709 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
710 msg="remaining $test_remaining test(s)"
11d54b8b 711 else
b73d9a23 712 test_remaining=$test_count
11d54b8b 713 msg="$test_count test(s)"
41ac414e 714 fi
e1970ce4 715 case "$test_failure" in
10b94e28 716 0)
5099b99d 717 # Maybe print SKIP message
bf4b7219
RJ
718 if test -n "$skip_all" && test $test_count -gt 0
719 then
720 error "Can't use skip_all after running some tests"
721 fi
46f32a99 722 test -z "$skip_all" || skip_all=" # SKIP $skip_all"
5099b99d 723
1c0cc756
RJ
724 if test $test_external_has_tap -eq 0
725 then
b73d9a23 726 if test $test_remaining -gt 0
d87bd7c1 727 then
633fe50a 728 say_color pass "# passed all $msg"
d87bd7c1 729 fi
633fe50a 730 say "1..$test_count$skip_all"
d998bd4a 731 fi
abc5d372
JS
732
733 test -d "$remove_trash" &&
734 cd "$(dirname "$remove_trash")" &&
735 rm -rf "$(basename "$remove_trash")"
736
342e9ef2
TR
737 test_at_end_hook_
738
e1970ce4
JH
739 exit 0 ;;
740
741 *)
1c0cc756
RJ
742 if test $test_external_has_tap -eq 0
743 then
633fe50a
TR
744 say_color error "# failed $test_failure among $msg"
745 say "1..$test_count"
d998bd4a 746 fi
5099b99d 747
e1970ce4
JH
748 exit 1 ;;
749
750 esac
751}
752
e4597aae 753if test -n "$valgrind"
4e1be63c 754then
4e1be63c
JS
755 make_symlink () {
756 test -h "$2" &&
757 test "$1" = "$(readlink "$2")" || {
758 # be super paranoid
759 if mkdir "$2".lock
760 then
761 rm -f "$2" &&
762 ln -s "$1" "$2" &&
763 rm -r "$2".lock
764 else
765 while test -d "$2".lock
766 do
767 say "Waiting for lock on $2."
768 sleep 1
769 done
770 fi
771 }
772 }
773
774 make_valgrind_symlink () {
36bfb0e5 775 # handle only executables, unless they are shell libraries that
11d62145 776 # need to be in the exec-path.
36bfb0e5 777 test -x "$1" ||
11d62145 778 test "# " = "$(head -c 2 <"$1")" ||
36bfb0e5 779 return;
4e1be63c
JS
780
781 base=$(basename "$1")
6cec5c68 782 symlink_target=$GIT_BUILD_DIR/$base
4e1be63c
JS
783 # do not override scripts
784 if test -x "$symlink_target" &&
785 test ! -d "$symlink_target" &&
786 test "#!" != "$(head -c 2 < "$symlink_target")"
787 then
788 symlink_target=../valgrind.sh
789 fi
efd92ffd
JS
790 case "$base" in
791 *.sh|*.perl)
792 symlink_target=../unprocessed-script
793 esac
4e1be63c
JS
794 # create the link, or replace it if it is out of date
795 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
796 }
797
26a07309
TR
798 # override all git executables in TEST_DIRECTORY/..
799 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
800 mkdir -p "$GIT_VALGRIND"/bin
801 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
802 do
803 make_valgrind_symlink $file
804 done
805 # special-case the mergetools loadables
806 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
807 OLDIFS=$IFS
808 IFS=:
809 for path in $PATH
810 do
811 ls "$path"/git-* 2> /dev/null |
812 while read file
ad0e6233 813 do
26a07309 814 make_valgrind_symlink "$file"
ad0e6233 815 done
26a07309
TR
816 done
817 IFS=$OLDIFS
4e1be63c
JS
818 PATH=$GIT_VALGRIND/bin:$PATH
819 GIT_EXEC_PATH=$GIT_VALGRIND/bin
820 export GIT_VALGRIND
952af351
TR
821 GIT_VALGRIND_MODE="$valgrind"
822 export GIT_VALGRIND_MODE
5dfc368f 823 GIT_VALGRIND_ENABLED=t
26a07309 824 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
5dfc368f 825 export GIT_VALGRIND_ENABLED
1c0cc756
RJ
826elif test -n "$GIT_TEST_INSTALLED"
827then
e4597aae
MO
828 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
829 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 830 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
831 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
832else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 833 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1c0cc756
RJ
834 if ! test -x "$git_bin_dir/git"
835 then
836 if test -z "$with_dashes"
837 then
e4597aae
MO
838 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
839 fi
840 with_dashes=t
841 fi
842 PATH="$git_bin_dir:$PATH"
6cec5c68 843 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
844 if test -n "$with_dashes"
845 then
6cec5c68 846 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 847 fi
4e1be63c 848fi
6cec5c68 849GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 850GIT_CONFIG_NOSYSTEM=1
3c995beb 851GIT_ATTR_NOSYSTEM=1
8f323c00 852export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 853
5e87eae9
JH
854if test -z "$GIT_TEST_CMP"
855then
856 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
857 then
858 GIT_TEST_CMP="$DIFF -c"
859 else
860 GIT_TEST_CMP="$DIFF -u"
861 fi
862fi
863
6cec5c68 864GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 865export GITPERLLIB
6cec5c68 866test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
867 error "You haven't built things yet, have you?"
868}
e1970ce4 869
1c0cc756
RJ
870if ! test -x "$GIT_BUILD_DIR"/test-chmtime
871then
56cf9806
EW
872 echo >&2 'You need to build test-chmtime:'
873 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
874 exit 1
875fi
876
e1970ce4 877# Test repository
002d4ce8
JK
878TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
879test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
880case "$TRASH_DIRECTORY" in
881/*) ;; # absolute path is good
882 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
f423ef5f 883esac
91c8b825 884test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
38b074de 885rm -fr "$TRASH_DIRECTORY" || {
6e7b5aaf 886 GIT_EXIT_OK=t
8d14ac94
JH
887 echo >&5 "FATAL: Cannot prepare test area"
888 exit 1
889}
890
90cff968 891HOME="$TRASH_DIRECTORY"
0ea47f9d
JH
892GNUPGHOME="$HOME/gnupg-home-not-used"
893export HOME GNUPGHOME
90cff968 894
1c0cc756
RJ
895if test -z "$TEST_NO_CREATE_REPO"
896then
38b074de 897 test_create_repo "$TRASH_DIRECTORY"
342e9ef2 898else
38b074de 899 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 900fi
1bd9c648
LW
901# Use -P to resolve symlinks in our working directory so that the cwd
902# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 903cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 904
d5d9de1b
JS
905this_test=${0##*/}
906this_test=${this_test%%-*}
e6a6ddc9
TR
907if match_pattern_list "$this_test" $GIT_SKIP_TESTS
908then
909 say_color info >&3 "skipping test $this_test altogether"
910 skip_all="skip all tests in $this_test"
911 test_done
912fi
f17e9fbb 913
8648732e
BC
914# Provide an implementation of the 'yes' utility
915yes () {
916 if test $# = 0
917 then
918 y=y
919 else
920 y="$*"
921 fi
922
6129c930
JS
923 i=0
924 while test $i -lt 99
8648732e 925 do
6129c930
JS
926 echo "$y"
927 i=$(($i+1))
8648732e
BC
928 done
929}
930
f17e9fbb
JS
931# Fix some commands on Windows
932case $(uname -s) in
933*MINGW*)
934 # Windows has its own (incompatible) sort and find
935 sort () {
936 /usr/bin/sort "$@"
937 }
938 find () {
939 /usr/bin/find "$@"
940 }
5397ea31
JS
941 sum () {
942 md5sum "$@"
943 }
4114156a
JS
944 # git sees Windows-style pwd
945 pwd () {
946 builtin pwd -W
947 }
ee9fb68c 948 # no POSIX permissions
6fd1106a 949 # backslashes in pathspec are converted to '/'
fb9a2bea 950 # exec does not inherit the PID
a94114ad 951 test_set_prereq MINGW
5f4e02e5 952 test_set_prereq NATIVE_CRLF
a31d0665 953 test_set_prereq SED_STRIPS_CR
97669eed 954 test_set_prereq GREP_STRIPS_CR
4d715ac0 955 GIT_TEST_CMP=mingw_test_cmp
a31d0665
RJ
956 ;;
957*CYGWIN*)
958 test_set_prereq POSIXPERM
a31d0665 959 test_set_prereq EXECKEEPSPID
cfa96496 960 test_set_prereq CYGWIN
a31d0665 961 test_set_prereq SED_STRIPS_CR
97669eed 962 test_set_prereq GREP_STRIPS_CR
ee9fb68c
JS
963 ;;
964*)
965 test_set_prereq POSIXPERM
6fd1106a 966 test_set_prereq BSLASHPSPEC
fb9a2bea 967 test_set_prereq EXECKEEPSPID
f17e9fbb
JS
968 ;;
969esac
704a3143 970
b082687c 971( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 972test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 973test -z "$NO_PYTHON" && test_set_prereq PYTHON
8f852ce6 974test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
5e9637c6 975test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 976
bb946bba 977# Can we rely on git's output in the C locale?
30955229
JN
978if test -n "$GETTEXT_POISON"
979then
980 GIT_GETTEXT_POISON=YesPlease
981 export GIT_GETTEXT_POISON
5e9637c6 982 test_set_prereq GETTEXT_POISON
30955229
JN
983else
984 test_set_prereq C_LOCALE_OUTPUT
985fi
bb946bba 986
cabdee2c
JH
987# Use this instead of test_cmp to compare files that contain expected and
988# actual output from git commands that can be translated. When running
989# under GETTEXT_POISON this pretends that the command produced expected
990# results.
991test_i18ncmp () {
992 test -n "$GETTEXT_POISON" || test_cmp "$@"
993}
994
127df8c6
JH
995# Use this instead of "grep expected-string actual" to see if the
996# output from a git command that can be translated either contains an
997# expected string, or does not contain an unwanted one. When running
998# under GETTEXT_POISON this pretends that the command produced expected
999# results.
1000test_i18ngrep () {
1001 if test -n "$GETTEXT_POISON"
1002 then
1003 : # pretend success
1004 elif test "x!" = "x$1"
1005 then
1006 shift
1007 ! grep "$@"
1008 else
1009 grep "$@"
1010 fi
1011}
1012
20073274
AS
1013test_lazy_prereq PIPE '
1014 # test whether the filesystem supports FIFOs
9443605b 1015 case $(uname -s) in
a1f32964 1016 CYGWIN*|MINGW*)
9443605b
ML
1017 false
1018 ;;
1019 *)
1020 rm -f testfifo && mkfifo testfifo
1021 ;;
1022 esac
20073274
AS
1023'
1024
04083f27
JH
1025test_lazy_prereq SYMLINKS '
1026 # test whether the filesystem supports symbolic links
1027 ln -s x y && test -h y
1028'
c91cfd19 1029
b018c735
JN
1030test_lazy_prereq FILEMODE '
1031 test "$(git config --bool core.filemode)" = true
1032'
1033
ac39aa61
MG
1034test_lazy_prereq CASE_INSENSITIVE_FS '
1035 echo good >CamelCase &&
1036 echo bad >camelcase &&
1037 test "$(cat CamelCase)" != good
1038'
1039
5b0b5dd4
MG
1040test_lazy_prereq UTF8_NFD_TO_NFC '
1041 # check whether FS converts nfd unicode to nfc
1042 auml=$(printf "\303\244")
1043 aumlcdiar=$(printf "\141\314\210")
1044 >"$auml" &&
1045 case "$(echo *)" in
1046 "$aumlcdiar")
1047 true ;;
1048 *)
1049 false ;;
1050 esac
1051'
1052
09feffb6
JK
1053test_lazy_prereq AUTOIDENT '
1054 sane_unset GIT_AUTHOR_NAME &&
1055 sane_unset GIT_AUTHOR_EMAIL &&
1056 git var GIT_AUTHOR_IDENT
1057'
1058
6219bb22
JH
1059test_lazy_prereq EXPENSIVE '
1060 test -n "$GIT_TEST_LONG"
1061'
1062
e1ecd9e3
JH
1063test_lazy_prereq USR_BIN_TIME '
1064 test -x /usr/bin/time
1065'
1066
1767c517
JK
1067test_lazy_prereq NOT_ROOT '
1068 uid=$(id -u) &&
1069 test "$uid" != 0
1070'
1071
719c3da2
JH
1072# SANITY is about "can you correctly predict what the filesystem would
1073# do by only looking at the permission bits of the files and
1074# directories?" A typical example of !SANITY is running the test
1075# suite as root, where a test may expect "chmod -r file && cat file"
1076# to fail because file is supposed to be unreadable after a successful
1077# chmod. In an environment (i.e. combination of what filesystem is
1078# being used and who is running the tests) that lacks SANITY, you may
1079# be able to delete or create a file when the containing directory
1080# doesn't have write permissions, or access a file even if the
1081# containing directory doesn't have read or execute permissions.
1082
f400e51c
TB
1083test_lazy_prereq SANITY '
1084 mkdir SANETESTD.1 SANETESTD.2 &&
1085
1086 chmod +w SANETESTD.1 SANETESTD.2 &&
1087 >SANETESTD.1/x 2>SANETESTD.2/x &&
1088 chmod -w SANETESTD.1 &&
719c3da2 1089 chmod -r SANETESTD.1/x &&
f400e51c
TB
1090 chmod -rx SANETESTD.2 ||
1091 error "bug in test sript: cannot prepare SANETESTD"
1092
719c3da2 1093 ! test -r SANETESTD.1/x &&
f400e51c
TB
1094 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1095 status=$?
1096
1097 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1098 rm -rf SANETESTD.1 SANETESTD.2 ||
1099 error "bug in test sript: cannot clean SANETESTD"
1100 return $status
1101'
f838ce58
JK
1102
1103GIT_UNZIP=${GIT_UNZIP:-unzip}
1104test_lazy_prereq UNZIP '
1105 "$GIT_UNZIP" -v
1106 test $? -ne 127
1107'
9a308de3
JK
1108
1109run_with_limited_cmdline () {
1110 (ulimit -s 128 && "$@")
1111}
1112
1113test_lazy_prereq CMDLINE_LIMIT 'run_with_limited_cmdline true'